<template>
  <div class="custom-control custom-switch py-1">
    <input type="checkbox" class="custom-control-input" :id="identifier" v-model="model">
    <label class="custom-control-label" :for="identifier">
      <i v-bind:class="classObject" :title="title"></i>
      <template v-if="notext"></template>
      <template v-else>{{ title }}</template>
    </label>
  </div>
</template>

<script>
import { SET_WORKSPACE_LAYER_STATUS } from '@/store'

export default {
  name: 'layercheckbox',

  props: {
    identifier: {
      type: String,
      required: true,
    },

    notext: {
      type: Boolean,
      default: false,
    },
  },

  computed: {
    workspace: {
      get() {
        return this.$parent.workspace
      }
    },

    layer: {
      get() {
        return this.$store.getters.workspaceLayers(this.workspace)[this.identifier]
      },
    },

    icon: {
      get() {
        return this.layer.icon
      },
    },

    title: {
      get() {
        return this.layer.title
      },
    },

    classObject: {
      get() {
        let d = {}
        d['wi ' + this.icon] = true
        return d
      }
    },

    model: {
      get() {
        return this.layer.active
      },

      set(value) {
        this.$store.commit(SET_WORKSPACE_LAYER_STATUS, {
          workspaceId: this.workspace,
          layerId: this.identifier,
          value: value,
        })
      },
    },
  },
}
</script>
